## veccore 0.8.0+ds1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

include(cmake/RecordCmdLine.cmake)

project(VecCore LANGUAGES C CXX VERSION 0.8.0
    DESCRIPTION "C++ Library for Portable SIMD Vectorization")

set(CMAKE_CXX_STANDARD 11 CACHE STRING "C++ ISO Standard")
set(CMAKE_CXX_STANDARD_REQUIRED True)

list(INSERT CMAKE_MODULE_PATH 0 ${PROJECT_SOURCE_DIR}/cmake)

option(CUDA    "Enable support for CUDA")
option(UMESIMD "Enable UME::SIMD backend")
option(VC      "Enable Vc backend")

option(BUILD_DOCS       "Build doxygen documentation")
option(BUILD_BENCHMARKS "Build binaries for performance benchmarking")
option(BUILD_TESTING    "Build test binaries and create test target")

option(BUILD_GOOGLETEST  "Build GoogleTest from source")
option(BUILD_GOOGLEBENCH "Build Google benchmark from source")
option(BUILD_UMESIMD     "Build UME::SIMD library from source")
option(BUILD_VC          "Build Vc library from source")

include(CompilerSetup)

if (CUDA)
  include(CUDA)
endif()

add_library(VecCore INTERFACE)

include(Builtins)

if (VC)
  find_package(Vc 1.3.3 REQUIRED)

  # Vc does not come with an imported target, add our own
  if(NOT TARGET Vc::Vc)
    add_library(Vc::Vc INTERFACE IMPORTED)
    set_property(TARGET Vc::Vc PROPERTY INTERFACE_INCLUDE_DIRECTORIES ${Vc_INCLUDE_DIRS})
    set_property(TARGET Vc::Vc PROPERTY INTERFACE_LINK_LIBRARIES ${Vc_LIBRARIES})
  endif()

  target_compile_definitions(VecCore INTERFACE VECCORE_ENABLE_VC)
  target_link_libraries(VecCore INTERFACE Vc::Vc)
endif()

if (UMESIMD)
  find_package(UMESIMD 0.8.1 REQUIRED)
  target_compile_definitions(VecCore INTERFACE VECCORE_ENABLE_UMESIMD)
  target_link_libraries(VecCore INTERFACE UMESIMD::UMESIMD)
endif()

if (CUDA)
  target_compile_definitions(VecCore INTERFACE VECCORE_ENABLE_CUDA)
  target_include_directories(VecCore INTERFACE ${CUDA_INCLUDE_DIRS})
  target_link_libraries(VecCore INTERFACE ${CUDA_LIBRARIES})
endif()

include_directories(include)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

write_basic_package_version_file(cmake/VecCoreConfigVersion.cmake
  VERSION ${VecCore_VERSION} COMPATIBILITY SameMajorVersion)

configure_package_config_file(cmake/VecCoreConfig.cmake.in cmake/VecCoreConfig.cmake
  INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
  PATH_VARS CMAKE_INSTALL_INCLUDEDIR
)

install(DIRECTORY include/${PROJECT_NAME}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES cmake/FindUMESIMD.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
install(DIRECTORY ${PROJECT_BINARY_DIR}/cmake/
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

if (BUILD_DOCS)
  add_subdirectory(doc)
endif()

enable_testing()

if (BUILD_TESTING)
  add_subdirectory(test)
endif()

if (BUILD_BENCHMARKS)
  add_subdirectory(bench)
endif()

=== bench/CMakeLists.txt ===
# VecCore Benchmarks

find_package(benchmark REQUIRED)

# Avoid deprecation warning from Vc
if(NOT MSVC)
  add_compile_options(-Wno-deprecated-declarations)
endif()

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
  # prevent ICC from issuing streaming stores,
  # which obfuscate the timings for benchmarks
  add_compile_options(-qopt-streaming-stores=never)
endif()

add_executable(mathbench math_benchmarks.cc)
target_link_libraries(mathbench
  benchmark::benchmark benchmark::benchmark_main VecCore)

if(BUILD_TESTING)
  add_test(NAME bench-math COMMAND mathbench)
endif()

add_executable(mathbench-fast math_benchmarks.cc)
target_compile_options(mathbench-fast PRIVATE
  $<IF:$<BOOL:${MSVC}>,/fp:fast,-ffast-math>)
target_link_libraries(mathbench-fast
  benchmark::benchmark benchmark::benchmark_main VecCore)

add_executable(quadratic quadratic.cc)
target_link_libraries(quadratic VecCore)

add_executable(nbody nbody.cc)
target_link_libraries(nbody VecCore)

find_package(PkgConfig)

if(PKG_CONFIG_FOUND)
  pkg_check_modules(GD IMPORTED_TARGET gdlib)
endif()

add_library(png STATIC png.cc)

if (GD_FOUND)
  target_compile_definitions(png PUBLIC HAVE_GD)
  target_link_libraries(png PUBLIC PkgConfig::GD)
endif()

foreach(target julia mandelbrot newton)
  add_executable(${target} ${target}.cc)
  target_link_libraries(${target} png VecCore)
endforeach()

if(BUILD_TESTING)
  foreach(target julia mandelbrot newton quadratic nbody)
    add_test(NAME bench-${target} COMMAND ${target})
  endforeach()
endif()

=== doc/CMakeLists.txt ===
find_package(Doxygen REQUIRED dot)

set(DOXYGEN_BUILTIN_STL_SUPPORT   TRUE)
set(DOXYGEN_CALLER_GRAPH          TRUE)
set(DOXYGEN_CALL_GRAPH            TRUE)
set(DOXYGEN_CLASS_DIAGRAMS        TRUE)
set(DOXYGEN_CPP_CLI_SUPPORT       TRUE)
set(DOXYGEN_EXTRACT_ALL           TRUE)
set(DOXYGEN_GENERATE_TREEVIEW     TRUE)
set(DOXYGEN_GRAPHICAL_HIERARCHY   TRUE)
set(DOXYGEN_INLINE_SIMPLE_STRUCTS TRUE)
set(DOXYGEN_INTERACTIVE_SVG       TRUE)
set(DOXYGEN_RECURSIVE             TRUE)
set(DOXYGEN_SOURCE_BROWSER        TRUE)
set(DOXYGEN_DOT_IMAGE_FORMAT       svg)
set(DOXYGEN_IMAGE_PATH ${CMAKE_CURRENT_SOURCE_DIR})
set(DOXYGEN_STRIP_FROM_PATH ${PROJECT_SOURCE_DIR} ${PROJECT_SOURCE_DIR}/include)
set(DOXYGEN_USE_MDFILE_AS_MAINPAGE README.md)

doxygen_add_docs(doxygen
  ${PROJECT_SOURCE_DIR}/README.md
  ${PROJECT_SOURCE_DIR}/doc/api.md
  ${PROJECT_SOURCE_DIR}/doc/backends.md
  ${PROJECT_SOURCE_DIR}/doc/publications.md
  ${PROJECT_SOURCE_DIR}/include
)

=== test/cuda/CMakeLists.txt ===
cuda_add_executable(hello hello.cu)
target_link_libraries(hello VecCore)
add_test(CUDAHelloWorld hello)

=== debian/changelog ===
veccore (0.8.0+ds1-1) unstable; urgency=medium

  * New upstream version 0.8.0+ds1
  * Upload to unstable

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 13 Oct 2021 13:21:54 +0200

veccore (0.7.0+ds1-1) experimental; urgency=medium

  * Initial release (Closes: #988525)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Sun, 16 May 2021 18:50:03 +0200

=== debian/control ===
Source: veccore
Priority: optional
Maintainer: Stephan Lachnit <stephanlachnit@debian.org>
Uploaders: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Standards-Version: 4.6.0.1
Section: libs
Homepage: https://github.com/root-project/veccore
Vcs-Browser: https://salsa.debian.org/science-team/veccore
Vcs-Git: https://salsa.debian.org/science-team/veccore.git
Rules-Requires-Root: no

Package: veccore-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Recommends:
 vc-dev [any-amd64 any-arm any-arm64 any-i386],
Description: simple abstraction layer on top of other vectorization libraries
 It provides an architecture-independent API for expressing vector operations
 on data. Code written with this API can then be dispatched to one of several
 backends like Vc, or a scalar implementation. This allows one to get the best
 performance on platforms supported by Vc without losing portability to
 unsupported architectures like ARM and PowerPC, for example, where the scalar
 backend can be used instead without requiring changes in user code.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%veccore-$1.tar.gz%,dversionmangle=s%\+ds\d*$%%,repacksuffix=+ds1" \
    https://github.com/root-project/veccore/releases (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## veccore 0.8.1%2Bds1

=== debian/changelog ===
veccore (0.8.1+ds1-1) unstable; urgency=medium

  * New upstream version 0.8.1+ds1

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 26 Oct 2023 18:45:26 +0200

veccore (0.8.0+ds1-2) unstable; urgency=medium

  * Update standards version to 4.6.1, no changes needed
  * Fix watch file due to GitHub changes

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 09 Nov 2022 22:06:58 +0100

## veccore 0.8.1+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
-cmake_minimum_required(VERSION 3.9)
+cmake_minimum_required(VERSION 3.16...3.25)
 
 include(cmake/RecordCmdLine.cmake)
 
-project(VecCore LANGUAGES C CXX VERSION 0.8.0
+project(VecCore LANGUAGES C CXX VERSION 0.8.1
     DESCRIPTION "C++ Library for Portable SIMD Vectorization")
 
 set(CMAKE_CXX_STANDARD 11 CACHE STRING "C++ ISO Standard")

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

option(DETAILED_TEST_REPORT "Report fine grained test results" OFF)

if (CUDA)
  add_subdirectory(cuda)
endif()

find_package(GTest REQUIRED)

include(GoogleTest)

add_executable(test-backends
  align.cc
  arithmetics.cc
  constructors.cc
  interface.cc
  limits.cc
  mask.cc
  math.cc
  traits.cc
)

target_link_libraries(test-backends
  GTest::GTest GTest::Main VecCore)

if(DETAILED_TEST_REPORT)
  gtest_discover_tests(test-backends NO_PRETTY_TYPES)
else()
  add_test(NAME test-backends
    COMMAND test-backends --gtest_brief=1)
endif()

=== debian/changelog ===
veccore (0.8.1+ds1-2) unstable; urgency=medium

  * Team upload.
  * Fix typo in ScalarWrapper.h causing build failure in src:vecgeom
    when using GCC 15. Closes: #1098061.
  * Drop "Rules-Requires-Root: no" (default).
  * Update standards-version.

 -- Santiago Vila <sanvila@debian.org>  Sat, 25 Oct 2025 20:34:00 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: veccore
 Priority: optional
-Maintainer: Stephan Lachnit <stephanlachnit@debian.org>
-Uploaders: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Stephan Lachnit <stephanlachnit@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
-Standards-Version: 4.6.0.1
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/root-project/veccore
 Vcs-Browser: https://salsa.debian.org/science-team/veccore
 Vcs-Git: https://salsa.debian.org/science-team/veccore.git
-Rules-Requires-Root: no
 
 Package: veccore-dev
 Section: libdevel
